#ifndef _TTWAV_H_
#define _TTWAV_H_
#include <windows.h>
#include <stdio.h>

class TtWav {
  // static
public:
  static const int RIFF_HEADER = 0x46464952; // *((int *)"RIFF");
  static const int WAVE_HEADER = 0x45564157; // *((int *)"WAVE");
  static const int fmt_CHUNK   = 0x20746D66; // *((int *)"fmt ");
  static const int data_CHUNK  = 0x61746164; // *((int *)"data");
  static const int fmt_BYTE_SIZE = 16;
  static const int fmt_ID        =  1;

  static const short VOL_MAX =  32767;
  static const short VOL_MIN = -32768;
  
  
protected:
  int channel_count;
  int frequency;
  int bit_rate;
  int data_size;
  int memory_size;
  char *data;
  bool debug;

public:
  TtWav();
  ~TtWav();
  void make_blank();

  int get_channel_count();
  int get_frequency();
  int get_bit_rate();
  int get_data_size();
  int get_memory_size();
  
  void set_debug( bool flag );
  
  bool read_file( char *filepath );

private:
  bool read_int( int *data, FILE *file );
  bool read_2byte( int *data, FILE *file );

public:
  bool write_file( char *filepath );

private:
  bool write_int( int data, FILE *file );
  bool write_2byte( int data, FILE *file );

public:
  void to_2ch();
  void to_16bit_rate();
  void to_44kHz();

  void memory_extend( int size );

  void change_volume( int percentage );
  void mixin_at( int position, TtWav *other );
  void deduct_at( int position, TtWav *other, int other_index );
  
  
};

#endif // _TTWAV_H_
